#include <MsTimer2.h>               //定时器库的 头文件
#include "TM1637.h"
#include "DFRobot_Gesture_Touch.h"

#ifdef __AVR__
  #include "SoftwareSerial.h"
  SoftwareSerial    mySerial(10, 11);         // example for uno, use software serial
#elif defined ESP_PLATFORM
  #include "HardwareSerial.h"
  HardwareSerial    mySerial(1);
#endif

DFRobot_Gesture_Touch   DFGT(&mySerial);    // init sensor object, request write and read function
#define Buzz A2 //蜂鸣器

// Pins definitions for TM1637 and can be changed to other ports
const int CLK = A0;
const int DIO = A1;
TM1637 tm1637(CLK, DIO);
static boolean point_flag = HIGH;//显示中间两个点
static boolean alarm = LOW;//时间到了报警提示


int8_t TimeDisp[] = {0x00, 0x00, 0x00, 0x00};

int Sec = 0;//定义秒
int Min = 0;//定义分
bool setting = 0;  //设置时间模式
bool start_count = 0;  //开始计时
int time_num ;

void flash()                        //中断处理函数，改变灯的状态
{                        
 point_flag = !point_flag;

 if(start_count == 1){

 Sec--;
 }
 tm1637.point(POINT_ON);
}

void Ring()
{
  digitalWrite(Buzz,HIGH);
  delay(50);
  digitalWrite(Buzz,LOW);
  delay(50);
  }
 
void setup() 
{
  Serial.begin(115200);
  mySerial.begin(9600);
  delay(500);
  while(mySerial.available())  // flush serial buffer
  mySerial.read();
  Serial.println("gesture&touch sensor test");

   DFGT.setGestureDistance(15);             // suggest default value
   DFGT.enableFunction(DFGT_FUN_ALL);       // enable all functions
  //DFGT.disableFunction(DFGT_FUN_RIGHT | DFGT_FUN_LEFT);    // disable function test
   DFGT.enableFunction(DFGT_FUN_RIGHT | DFGT_FUN_LEFT);     // enable function test
   DFGT.setSleep(6);                        // set auto sleep time out, in sleep mode, something  approach will weak it up
  pinMode(Buzz,OUTPUT);
  
  tm1637.init();
  tm1637.set(BRIGHT_TYPICAL);//BRIGHT_TYPICAL = 2,BRIGHT_DARKEST = 0,BRIGHTEST = 7;
  Min = 0;
  Sec = 0 ;
  tm1637.display(TimeDisp);
  tm1637.displayStr("LOUE");
   //tm1637.displayNum(1234,0);
   delay(1000);
  
  MsTimer2::set(1000, flash);        // 中断设置函数，每 1000ms 进入一次中断
  MsTimer2::start();                //开始计时

}
 
void loop() {

    int8_t    rslt = DFGT.getAnEvent();  // get an event that data saved in serial buffer
  if(rslt != DF_ERR) {
    // DFGT.setSleep(DFGT_SLEEP_DISABLE);  // disable auto sleep
    switch(rslt) {
      case DFGT_EVT_BACK: {
        Serial.println("get event back");

        Ring();
       if(setting == 1){
          Min = 5;
          Sec = 0;
        }
  
      } break;
      case DFGT_EVT_FORWARD: {
        Serial.println("get event forward");

      Ring();
       if(setting == 1){
          Min = 15;
          Sec = 0;
        }
   
      } break;
      case DFGT_EVT_RIGHT: {

      Ring();
        Serial.println("get event right");
       if(setting == 1){
          Min = 10;
          Sec = 0;
        }

      } break;
      case DFGT_EVT_LEFT: {
        Serial.println("get event left");

      Ring();
       if(setting == 1){
          Min = 3;
          Sec = 0;
        }

      } break;
      case DFGT_EVT_PULLUP: {
        Serial.println("get event pull up");
        
        Ring();
        setting = 1;//进入设置模式*/
        start_count = 0;//停止计时
        alarm = 0;     
        Min=88;
        Sec=88;
        
        
      } break;
      case DFGT_EVT_PULLDOWN: { 
        Serial.println("get event pull down");  
        
         Ring();
         Ring();
        alarm = 0;  
       if( Min>0 && Sec==0){
        start_count = 1;//开始计时
        setting = 0;//退出设置模式*/
       }
        
      } break;
      case DFGT_EVT_PULLREMOVE: {
        Serial.println("get event pull and remove");
        
        /*digitalWrite(Buzz,HIGH);
        delay(200);
        digitalWrite(Buzz,LOW);
        delay(200); 
        setting = 1;//进入设置模式*/
        
      } break;
     /* case DFGT_EVT_TOUCH1: {
        Serial.println("get event touch1");
        digitalWrite(Buzz,HIGH);
        delay(50);
        digitalWrite(Buzz,LOW);
        delay(50);        
      } break;
      case DFGT_EVT_TOUCH2: {
        Serial.println("get event touch2");
      } break;
      case DFGT_EVT_TOUCH3: {
        Serial.println("get event touch3");
      } break;
      case DFGT_EVT_TOUCH4: {
        Serial.println("get event touch4");
      } break;
      case DFGT_EVT_TOUCH5: {
        Serial.println("get event touch5");
      } break;*/
    }
  }
  if(Sec == -1)
 {
  Sec = 59;
  Min--;
  }
  
  if(start_count==1 && Min == 0 && Sec ==0 )
 {
      Min = 0;  
      Sec = 0;
      start_count = 0;
      TimeDisp[3] = Sec % 10;
      tm1637.display(TimeDisp);
      alarm = 1;
  }
          
    if( start_count || setting ) { 
    TimeDisp[0] = Min / 10;
    TimeDisp[1] = Min % 10;
    TimeDisp[2] = Sec / 10;
    TimeDisp[3] = Sec % 10;
    tm1637.display(TimeDisp);
    }


   if(point_flag){
    tm1637.point(POINT_ON);
    if(alarm){
      digitalWrite(Buzz,HIGH);
      }
   }
   else {
    tm1637.point(POINT_OFF);
    if(alarm){
      digitalWrite(Buzz,LOW);
      }
      }

}
